if CLIENT then
SWEP.WepSelectIcon = surface.GetTextureID( "dukenukem3d/sprites/weapons/mighty_foot/icon" )
SWEP.DrawWeaponInfoBox	= false
SWEP.BounceWeaponIcon = false
killicon.Add( "weapon_dukenukem3d_mighty_foot", "dukenukem3d/sprites/weapons/mighty_foot/icon", Color( 255, 255, 255, 255 ) )
end

SWEP.PrintName = "Mighty Foot"
SWEP.Category = "Duke Nukem 3D"
SWEP.Spawnable= true
SWEP.AdminSpawnable= true
SWEP.AdminOnly = false

SWEP.ViewModelFOV = 60
SWEP.ViewModel = "models/dukenukem3d/weapons/v_weapon.mdl"
SWEP.WorldModel = ""
SWEP.ViewModelFlip = false

SWEP.AutoSwitchTo = false
SWEP.AutoSwitchFrom = false
SWEP.Weight = 0
SWEP.Slot = 0
SWEP.SlotPos = 0

SWEP.UseHands = false
SWEP.HoldType = "normal"
SWEP.FiresUnderwater = true
SWEP.DrawCrosshair = false
SWEP.DrawAmmo = true
SWEP.Base = "weapon_base"

SWEP.Sprite = 0
SWEP.SpriteTimer = CurTime()
SWEP.PositionX = 0
SWEP.PositionXDirection = 0
SWEP.PositionY = 0
SWEP.PositionYDirection = 0

SWEP.Primary.ClipSize = -1
SWEP.Primary.DefaultClip = -1
SWEP.Primary.Automatic = true
SWEP.Primary.Ammo = "none"

SWEP.Secondary.ClipSize = -1
SWEP.Secondary.DefaultClip = -1
SWEP.Secondary.Automatic = true
SWEP.Secondary.Ammo = "none"

function SWEP:Initialize()
self:SetWeaponHoldType( self.HoldType )
end

function SWEP:DrawHUD()
surface.SetDrawColor( 255, 255, 255, 255 )
surface.SetTexture( surface.GetTextureID( self.Weapon:GetNWInt( "Sprite", "dukenukem3d/sprites/weapons/mighty_foot/idle" ) ) )
surface.DrawTexturedRect( ScrW() * 5 / 12 + self.PositionX, ScrH() - ScrW() / 2 + self.PositionY, ScrW() / 2, ScrW() / 2 )
surface.SetDrawColor( 255, 255, 0, 200 )
surface.DrawRect( ScrW() / 2 - 12, ScrH() / 2 - 1, 8, 2 )
surface.DrawRect( ScrW() / 2 + 4, ScrH() / 2 - 1, 8, 2 )
surface.DrawRect( ScrW() / 2 - 1, ScrH() / 2 - 12, 2, 8 )
surface.DrawRect( ScrW() / 2 - 1, ScrH() / 2 + 4, 2, 8 )
end

function SWEP:Deploy()
self:SetWeaponHoldType( self.HoldType )
self:SetNextPrimaryFire( CurTime() + 0.2 )
self:SetNextSecondaryFire( CurTime() + 0.2 )
self.Sprite = 0
self.SpriteTimer = CurTime()
self.PositionX = 0
self.PositionXDirection = 0
self.PositionY = 0
self.PositionYDirection = 0
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/mighty_foot/idle" )
return true
end

function SWEP:Holster()
self.Sprite = 0
self.SpriteTimer = CurTime()
self.PositionX = 0
self.PositionXDirection = 0
self.PositionY = 0
self.PositionYDirection = 0
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/mighty_foot/idle" )
return true
end

function SWEP:PrimaryAttack()
if self.Sprite > 0 then
return
end
self.Owner:DoAnimationEvent( ACT_GMOD_GESTURE_MELEE_SHOVE_1HAND )
self.Sprite = 1
self.SpriteTimer = CurTime() + 0.2
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/mighty_foot/attack_1_right" )
end

function SWEP:SecondaryAttack()
end

function SWEP:Reload()
end

function SWEP:Think()
if self.Sprite == 1 and self.SpriteTimer <= CurTime() then
local tr = util.TraceLine( {
start = self.Owner:GetShootPos(),
endpos = self.Owner:GetShootPos() + self.Owner:GetAimVector() * 72,
filter = self.Owner,
mask = MASK_SHOT_HULL
} )
if !IsValid( tr.Entity ) then
tr = util.TraceHull( {
start = self.Owner:GetShootPos(),
endpos = self.Owner:GetShootPos() + self.Owner:GetAimVector() * 72,
filter = self.Owner,
mins = Vector( -16, -16, 0 ),
maxs = Vector( 16, 16, 0 ),
mask = MASK_SHOT_HULL
} )
end
if SERVER then
if tr.Hit then
self.Owner:EmitSound( "Weapon_DukeNukem3D_Mighty_Foot.Attack" )
end
if IsValid( tr.Entity ) then
local dmg = DamageInfo()
local attacker = self.Owner
if !IsValid( attacker ) then
attacker = self
end
dmg:SetAttacker( attacker )
dmg:SetInflictor( self )
dmg:SetDamage( 10 )
dmg:SetDamageType( DMG_CLUB )
dmg:SetDamageForce( self.Owner:GetForward() )
tr.Entity:TakeDamageInfo( dmg )
end
end
self.Sprite = 2
self.SpriteTimer = CurTime() + 0.2
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/mighty_foot/attack_2_right" )
end
if self.Sprite == 2 and self.SpriteTimer <= CurTime() then
self.Sprite = 3
self.SpriteTimer = CurTime() + 0.2
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/mighty_foot/attack_1_right" )
end
if self.Sprite == 3 and self.SpriteTimer <= CurTime() then
self.Sprite = 0
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/mighty_foot/idle" )
end
if self.Owner:IsOnGround() then
if self.PositionX <= 64 and self.PositionXDirection == 0 then
self.PositionX = self.PositionX + FrameTime() * 50 * ( self.Owner:GetVelocity():Length() / self.Owner:GetWalkSpeed() )
end
if self.PositionX > 64 then
self.PositionXDirection = 1
end
if self.PositionX >= 0 and self.PositionXDirection == 1 then
self.PositionX = self.PositionX - FrameTime() * 50 * ( self.Owner:GetVelocity():Length() / self.Owner:GetWalkSpeed() )
end
if self.PositionX < 0 then
self.PositionXDirection = 0
end
if self.PositionY <= 32 and self.PositionYDirection == 0 then
self.PositionY = self.PositionY + FrameTime() * 50 * ( self.Owner:GetVelocity():Length() / self.Owner:GetWalkSpeed() )
end
if self.PositionY > 32 then
self.PositionYDirection = 1
end
if self.PositionY >= 0 and self.PositionYDirection == 1 then
self.PositionY = self.PositionY - FrameTime() * 50 * ( self.Owner:GetVelocity():Length() / self.Owner:GetWalkSpeed() )
end
if self.PositionY < 0 then
self.PositionYDirection = 0
end
end
end