if CLIENT then
SWEP.WepSelectIcon = surface.GetTextureID( "dukenukem3d/sprites/weapons/pistol/icon" )
SWEP.DrawWeaponInfoBox	= false
SWEP.BounceWeaponIcon = false
killicon.Add( "weapon_dukenukem3d_pistol", "dukenukem3d/sprites/weapons/pistol/icon", Color( 255, 255, 255, 255 ) )
end

SWEP.PrintName = "Pistol"
SWEP.Category = "Duke Nukem 3D"
SWEP.Spawnable= true
SWEP.AdminSpawnable= true
SWEP.AdminOnly = false

SWEP.ViewModelFOV = 60
SWEP.ViewModel = "models/dukenukem3d/weapons/v_pistol.mdl"
SWEP.WorldModel = "models/dukenukem3d/weapons/w_pistol.mdl"
SWEP.ViewModelFlip = false

SWEP.AutoSwitchTo = false
SWEP.AutoSwitchFrom = false
SWEP.Weight = 1
SWEP.Slot = 1
SWEP.SlotPos = 0

SWEP.UseHands = false
SWEP.HoldType = "pistol"
SWEP.FiresUnderwater = true
SWEP.DrawCrosshair = false
SWEP.DrawAmmo = true
SWEP.Base = "weapon_base"

SWEP.Reloading = 0
SWEP.ReloadingTimer = CurTime()
SWEP.Sprite = 0
SWEP.SpriteTimer = CurTime()
SWEP.Melee = 0
SWEP.MeleeTimer = CurTime()
SWEP.PositionDraw = 128
SWEP.PositionX = 0
SWEP.PositionXDirection = 0
SWEP.PositionY = 0
SWEP.PositionYDirection = 0

SWEP.Primary.Sound = Sound( "Weapon_DukeNukem3D_Pistol.Attack" )
SWEP.Primary.ClipSize = 12
SWEP.Primary.DefaultClip = 48
SWEP.Primary.MaxAmmo = 200
SWEP.Primary.Automatic = true
SWEP.Primary.Ammo = "Pistol"
SWEP.Primary.Damage = 6
SWEP.Primary.TakeAmmo = 1
SWEP.Primary.Spread = 0.04
SWEP.Primary.NumberofShots = 1
SWEP.Primary.Delay = 0.15
SWEP.Primary.Force = 1

SWEP.Secondary.ClipSize = -1
SWEP.Secondary.DefaultClip = -1
SWEP.Secondary.Automatic = true
SWEP.Secondary.Ammo = "none"

function SWEP:Initialize()
self:SetWeaponHoldType( self.HoldType )
end

function SWEP:DrawHUD()
surface.SetDrawColor( 255, 255, 255, 255 )
surface.SetTexture( surface.GetTextureID( self.Weapon:GetNWInt( "Melee", "dukenukem3d/sprites/weapons/mighty_foot/idle" ) ) )
surface.DrawTexturedRect( ScrW() / 12 - self.PositionX, ScrH() - ScrW() / 2 + self.PositionY, ScrW() / 2, ScrW() / 2 )
surface.SetTexture( surface.GetTextureID( self.Weapon:GetNWInt( "Sprite", "dukenukem3d/sprites/weapons/pistol/idle" ) ) )
surface.DrawTexturedRect( ScrW() / 2 + self.PositionX, ScrH() - ScrW() / 2 + self.PositionY + self.PositionDraw, ScrW() / 2, ScrW() / 2 )
surface.SetDrawColor( 255, 255, 0, 200 )
surface.DrawRect( ScrW() / 2 - 12, ScrH() / 2 - 1, 8, 2 )
surface.DrawRect( ScrW() / 2 + 4, ScrH() / 2 - 1, 8, 2 )
surface.DrawRect( ScrW() / 2 - 1, ScrH() / 2 - 12, 2, 8 )
surface.DrawRect( ScrW() / 2 - 1, ScrH() / 2 + 4, 2, 8 )
end

function SWEP:Deploy()
self:SetWeaponHoldType( self.HoldType )
if SERVER then
self.Owner:EmitSound( "Weapon_DukeNukem3D_Pistol.Reload_2" )
end
self:SetNextPrimaryFire( CurTime() + 0.2 )
self:SetNextSecondaryFire( CurTime() + 0.2 )
self.Reloading = 0
self.ReloadingTimer = CurTime() + 0.2
self.Sprite = 0
self.SpriteTimer = CurTime()
self.Melee = 0
self.MeleeTimer = CurTime()
self.PositionDraw = 128
self.PositionX = 0
self.PositionXDirection = 0
self.PositionY = 0
self.PositionYDirection = 0
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/pistol/idle" )
self.Weapon:SetNWInt( "Melee", "dukenukem3d/sprites/weapons/mighty_foot/idle" )
return true
end

function SWEP:Holster()
self.Reloading = 0
self.ReloadingTimer = CurTime()
self.Sprite = 0
self.SpriteTimer = CurTime()
self.Melee = 0
self.MeleeTimer = CurTime()
self.PositionDraw = 128
self.PositionX = 0
self.PositionXDirection = 0
self.PositionY = 0
self.PositionYDirection = 0
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/pistol/idle" )
self.Weapon:SetNWInt( "Melee", "dukenukem3d/sprites/weapons/mighty_foot/idle" )
return true
end

function SWEP:PrimaryAttack()
if self.Weapon:Clip1() <= 0 and self.Weapon:Ammo1() > 0 then
self:Reload()
end
if self.Weapon:Clip1() <= 0 || ( self.FiresUnderwater == false and self.Owner:WaterLevel() == 3 ) then
return
end
local bullet = {}
bullet.Num = self.Primary.NumberofShots
bullet.Src = self.Owner:GetShootPos()
bullet.Dir = self.Owner:GetAimVector()
bullet.Spread = Vector( self.Primary.Spread, self.Primary.Spread, 0 )
bullet.Tracer = 0
bullet.Force = self.Primary.Force
bullet.Damage = self.Primary.Damage
bullet.AmmoType = self.Primary.Ammo
self.Owner:FireBullets( bullet )
self:EmitSound( self.Primary.Sound )
self.Weapon:SendWeaponAnim( ACT_VM_PRIMARYATTACK )
self.Owner:SetAnimation( PLAYER_ATTACK1 )
self:TakePrimaryAmmo( self.Primary.TakeAmmo )
self:SetNextPrimaryFire( CurTime() + self.Primary.Delay )
self.ReloadingTimer = CurTime() + self.Primary.Delay
self.Sprite = 1
self.SpriteTimer = CurTime() + 0.1
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/pistol/attack_1" )
end

function SWEP:SecondaryAttack()
if self.Melee > 0 then
return
end
self.Owner:DoAnimationEvent( ACT_GMOD_GESTURE_MELEE_SHOVE_1HAND )
self.Melee = 1
self.MeleeTimer = CurTime() + 0.2
self.Weapon:SetNWInt( "Melee", "dukenukem3d/sprites/weapons/mighty_foot/attack_1_left" )
end

function SWEP:Reload()
if self.Weapon:Clip1() >= self.Primary.ClipSize || self.Weapon:Ammo1() <= 0 || self.Reloading == 1 || self.ReloadingTimer > CurTime() then
return
end
if SERVER then
self.Owner:EmitSound( "Weapon_DukeNukem3D_Pistol.Reload_1" )
end
self.Owner:SetAnimation( PLAYER_RELOAD )
self:SetNextPrimaryFire( CurTime() + 1 )
self.Reloading = 1
self.ReloadingTimer = CurTime() + 1
self.Sprite = 3
self.SpriteTimer = CurTime() + 0.1
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/pistol/reload_1" )
end

function SWEP:ReloadEnd()
if self.Weapon:Ammo1() > ( self.Primary.ClipSize - self.Weapon:Clip1() ) then
self.Owner:SetAmmo( self.Weapon:Ammo1() - self.Primary.ClipSize + self.Weapon:Clip1(), self.Primary.Ammo )
self.Weapon:SetClip1( self.Primary.ClipSize )
end
if ( self.Weapon:Ammo1() - self.Primary.ClipSize + self.Weapon:Clip1() ) + self.Weapon:Clip1() < self.Primary.ClipSize then
self.Weapon:SetClip1( self.Weapon:Clip1() + self.Weapon:Ammo1() )
self.Owner:SetAmmo( 0, self.Primary.Ammo )
end
self.Reloading = 0
end

function SWEP:Think()
if self.Reloading == 1 and self.ReloadingTimer <= CurTime() then
self:ReloadEnd()
end
if self.Sprite == 1 and self.SpriteTimer <= CurTime() then
self.Sprite = 2
self.SpriteTimer = CurTime() + 0.1
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/pistol/attack_2" )
end
if self.Sprite == 2 and self.SpriteTimer <= CurTime() then
self.Sprite = 0
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/pistol/idle" )
end
if self.Sprite == 3 and self.SpriteTimer <= CurTime() then
if SERVER then
self.Owner:EmitSound( "Weapon_DukeNukem3D_Pistol.Reload_2" )
end
self.Sprite = 4
self.SpriteTimer = CurTime() + 0.3
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/pistol/reload_2" )
end
if self.Sprite == 4 and self.SpriteTimer <= CurTime() then
self.Sprite = 5
self.SpriteTimer = CurTime() + 0.1
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/pistol/reload_3" )
end
if self.Sprite == 5 and self.SpriteTimer <= CurTime() then
self.Sprite = 6
self.SpriteTimer = CurTime() + 0.2
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/pistol/reload_4" )
end
if self.Sprite == 6 and self.SpriteTimer <= CurTime() then
self.Sprite = 2
self.SpriteTimer = CurTime() + 0.1
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/pistol/reload_1" )
end
if self.Melee == 1 and self.MeleeTimer <= CurTime() then
local tr = util.TraceLine( {
start = self.Owner:GetShootPos(),
endpos = self.Owner:GetShootPos() + self.Owner:GetAimVector() * 72,
filter = self.Owner,
mask = MASK_SHOT_HULL
} )
if !IsValid( tr.Entity ) then
tr = util.TraceHull( {
start = self.Owner:GetShootPos(),
endpos = self.Owner:GetShootPos() + self.Owner:GetAimVector() * 72,
filter = self.Owner,
mins = Vector( -16, -16, 0 ),
maxs = Vector( 16, 16, 0 ),
mask = MASK_SHOT_HULL
} )
end
if SERVER then
if tr.Hit then
self.Owner:EmitSound( "Weapon_DukeNukem3D_Mighty_Foot.Attack" )
end
if IsValid( tr.Entity ) then
local dmg = DamageInfo()
local attacker = self.Owner
if !IsValid( attacker ) then
attacker = self
end
dmg:SetAttacker( attacker )
dmg:SetInflictor( self )
dmg:SetDamage( 10 )
dmg:SetDamageType( DMG_CLUB )
dmg:SetDamageForce( self.Owner:GetForward() )
tr.Entity:TakeDamageInfo( dmg )
end
end
self.Melee = 2
self.MeleeTimer = CurTime() + 0.2
self.Weapon:SetNWInt( "Melee", "dukenukem3d/sprites/weapons/mighty_foot/attack_2_left" )
end
if self.Melee == 2 and self.MeleeTimer <= CurTime() then
self.Melee = 3
self.MeleeTimer = CurTime() + 0.2
self.Weapon:SetNWInt( "Melee", "dukenukem3d/sprites/weapons/mighty_foot/attack_1_left" )
end
if self.Melee == 3 and self.MeleeTimer <= CurTime() then
self.Melee = 0
self.Weapon:SetNWInt( "Melee", "dukenukem3d/sprites/weapons/mighty_foot/idle" )
end
if self.PositionDraw > FrameTime() * 150 then
self.PositionDraw = self.PositionDraw - FrameTime() * 150
end
if self.Owner:IsOnGround() then
if self.PositionX <= 64 and self.PositionXDirection == 0 then
self.PositionX = self.PositionX + FrameTime() * 50 * ( self.Owner:GetVelocity():Length() / self.Owner:GetWalkSpeed() )
end
if self.PositionX > 64 then
self.PositionXDirection = 1
end
if self.PositionX >= 0 and self.PositionXDirection == 1 then
self.PositionX = self.PositionX - FrameTime() * 50 * ( self.Owner:GetVelocity():Length() / self.Owner:GetWalkSpeed() )
end
if self.PositionX < 0 then
self.PositionXDirection = 0
end
if self.PositionY <= 32 and self.PositionYDirection == 0 then
self.PositionY = self.PositionY + FrameTime() * 50 * ( self.Owner:GetVelocity():Length() / self.Owner:GetWalkSpeed() )
end
if self.PositionY > 32 then
self.PositionYDirection = 1
end
if self.PositionY >= 0 and self.PositionYDirection == 1 then
self.PositionY = self.PositionY - FrameTime() * 50 * ( self.Owner:GetVelocity():Length() / self.Owner:GetWalkSpeed() )
end
if self.PositionY < 0 then
self.PositionYDirection = 0
end
end
if self.Weapon:Ammo1() > self.Primary.MaxAmmo then
self.Owner:SetAmmo( self.Primary.MaxAmmo, self.Primary.Ammo )
end
end