if CLIENT then
SWEP.WepSelectIcon = surface.GetTextureID( "dukenukem3d/sprites/weapons/rpg/icon" )
SWEP.DrawWeaponInfoBox	= false
SWEP.BounceWeaponIcon = false
killicon.Add( "weapon_dukenukem3d_rpg", "dukenukem3d/sprites/weapons/rpg/icon", Color( 255, 255, 255, 255 ) )
killicon.Add( "ent_dukenukem3d_rpg_projectile", "dukenukem3d/sprites/weapons/rpg/icon", Color( 255, 255, 255, 255 ) )
end

SWEP.PrintName = "RPG"
SWEP.Category = "Duke Nukem 3D"
SWEP.Spawnable= true
SWEP.AdminSpawnable= true
SWEP.AdminOnly = false

SWEP.ViewModelFOV = 60
SWEP.ViewModel = "models/dukenukem3d/weapons/v_weapon.mdl"
SWEP.WorldModel = "models/dukenukem3d/weapons/w_rpg.mdl"
SWEP.ViewModelFlip = false

SWEP.AutoSwitchTo = false
SWEP.AutoSwitchFrom = false
SWEP.Weight = 4
SWEP.Slot = 4
SWEP.SlotPos = 0

SWEP.UseHands = false
SWEP.HoldType = "shotgun"
SWEP.FiresUnderwater = false
SWEP.DrawCrosshair = false
SWEP.DrawAmmo = true
SWEP.Base = "weapon_base"

SWEP.Sprite = 0
SWEP.SpriteTimer = CurTime()
SWEP.Melee = 0
SWEP.MeleeTimer = CurTime()
SWEP.PositionDraw = 128
SWEP.PositionX = 0
SWEP.PositionXDirection = 0
SWEP.PositionY = 0
SWEP.PositionYDirection = 0

SWEP.Primary.Sound = Sound( "Weapon_DukeNukem3D_RPG.Attack" )
SWEP.Primary.ClipSize = -1
SWEP.Primary.DefaultClip = 5
SWEP.Primary.MaxAmmo = 50
SWEP.Primary.Automatic = true
SWEP.Primary.Ammo = "RPG_Round"
SWEP.Primary.TakeAmmo = 1
SWEP.Primary.Delay = 0.75
SWEP.Primary.Force = 1000

SWEP.Secondary.ClipSize = -1
SWEP.Secondary.DefaultClip = -1
SWEP.Secondary.Automatic = true
SWEP.Secondary.Ammo = "none"

function SWEP:Initialize()
self:SetWeaponHoldType( self.HoldType )
end

function SWEP:DrawHUD()
surface.SetDrawColor( 255, 255, 255, 255 )
surface.SetTexture( surface.GetTextureID( self.Weapon:GetNWInt( "Melee", "dukenukem3d/sprites/weapons/mighty_foot/idle" ) ) )
surface.DrawTexturedRect( ScrW() / 12 - self.PositionX, ScrH() - ScrW() / 2 + self.PositionY, ScrW() / 2, ScrW() / 2 )
surface.SetTexture( surface.GetTextureID( self.Weapon:GetNWInt( "Sprite", "dukenukem3d/sprites/weapons/rpg/idle" ) ) )
surface.DrawTexturedRect( self.PositionX, ScrH() - ScrW() / 2 + self.PositionY + self.PositionDraw, ScrW(), ScrW() / 2 )
surface.SetDrawColor( 255, 255, 0, 200 )
surface.DrawRect( ScrW() / 2 - 12, ScrH() / 2 - 1, 8, 2 )
surface.DrawRect( ScrW() / 2 + 4, ScrH() / 2 - 1, 8, 2 )
surface.DrawRect( ScrW() / 2 - 1, ScrH() / 2 - 12, 2, 8 )
surface.DrawRect( ScrW() / 2 - 1, ScrH() / 2 + 4, 2, 8 )
end

function SWEP:Deploy()
self:SetWeaponHoldType( self.HoldType )
if SERVER then
self.Owner:EmitSound( "Weapon_DukeNukem3D.Draw" )
end
self:SetNextPrimaryFire( CurTime() + 0.2 )
self:SetNextSecondaryFire( CurTime() + 0.2 )
self.Sprite = 0
self.SpriteTimer = CurTime()
self.Melee = 0
self.MeleeTimer = CurTime()
self.PositionDraw = 128
self.PositionX = 0
self.PositionXDirection = 0
self.PositionY = 0
self.PositionYDirection = 0
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/rpg/idle" )
self.Weapon:SetNWInt( "Melee", "dukenukem3d/sprites/weapons/mighty_foot/idle" )
return true
end

function SWEP:Holster()
self.Sprite = 0
self.SpriteTimer = CurTime()
self.Melee = 0
self.MeleeTimer = CurTime()
self.PositionDraw = 128
self.PositionX = 0
self.PositionXDirection = 0
self.PositionY = 0
self.PositionYDirection = 0
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/rpg/idle" )
self.Weapon:SetNWInt( "Melee", "dukenukem3d/sprites/weapons/mighty_foot/idle" )
return true
end

function SWEP:PrimaryAttack()
if self.Weapon:Ammo1() <= 0 || ( self.FiresUnderwater == false and self.Owner:WaterLevel() == 3 ) then
return
end
if SERVER then
local entity = ents.Create( "ent_dukenukem3d_rpg_projectile" )
entity:SetOwner( self.Owner )
entity:SetPos( self.Owner:GetShootPos() + self.Owner:EyeAngles():Forward() * 8 + self.Owner:EyeAngles():Right() * 8 - self.Owner:EyeAngles():Up() * 4 )
entity:SetAngles( self.Owner:EyeAngles() )
entity:Spawn()
entity:GetPhysicsObject():SetVelocity( self.Owner:GetAimVector() * self.Primary.Force )
end
self:EmitSound( self.Primary.Sound )
self.Owner:SetAnimation( PLAYER_ATTACK1 )
self:TakePrimaryAmmo( self.Primary.TakeAmmo )
self:SetNextPrimaryFire( CurTime() + self.Primary.Delay )
self.Sprite = 1
self.SpriteTimer = CurTime() + 0.1
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/rpg/attack_1" )
end

function SWEP:SecondaryAttack()
if self.Melee > 0 then
return
end
self.Owner:DoAnimationEvent( ACT_GMOD_GESTURE_MELEE_SHOVE_1HAND )
self.Melee = 1
self.MeleeTimer = CurTime() + 0.2
self.Weapon:SetNWInt( "Melee", "dukenukem3d/sprites/weapons/mighty_foot/attack_1_left" )
end

function SWEP:Reload()
end

function SWEP:Think()
if self.Sprite == 1 and self.SpriteTimer <= CurTime() then
self.Sprite = 2
self.SpriteTimer = CurTime() + 0.1
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/rpg/attack_2" )
end
if self.Sprite == 2 and self.SpriteTimer <= CurTime() then
self.Sprite = 3
self.SpriteTimer = CurTime() + 0.1
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/rpg/attack_3" )
end
if self.Sprite == 3 and self.SpriteTimer <= CurTime() then
self.Sprite = 0
self.Weapon:SetNWInt( "Sprite", "dukenukem3d/sprites/weapons/rpg/idle" )
end
if self.Melee == 1 and self.MeleeTimer <= CurTime() then
local tr = util.TraceLine( {
start = self.Owner:GetShootPos(),
endpos = self.Owner:GetShootPos() + self.Owner:GetAimVector() * 72,
filter = self.Owner,
mask = MASK_SHOT_HULL
} )
if !IsValid( tr.Entity ) then
tr = util.TraceHull( {
start = self.Owner:GetShootPos(),
endpos = self.Owner:GetShootPos() + self.Owner:GetAimVector() * 72,
filter = self.Owner,
mins = Vector( -16, -16, 0 ),
maxs = Vector( 16, 16, 0 ),
mask = MASK_SHOT_HULL
} )
end
if SERVER then
if tr.Hit then
self.Owner:EmitSound( "Weapon_DukeNukem3D_Mighty_Foot.Attack" )
end
if IsValid( tr.Entity ) then
local dmg = DamageInfo()
local attacker = self.Owner
if !IsValid( attacker ) then
attacker = self
end
dmg:SetAttacker( attacker )
dmg:SetInflictor( self )
dmg:SetDamage( 10 )
dmg:SetDamageType( DMG_CLUB )
dmg:SetDamageForce( self.Owner:GetForward() )
tr.Entity:TakeDamageInfo( dmg )
end
end
self.Melee = 2
self.MeleeTimer = CurTime() + 0.2
self.Weapon:SetNWInt( "Melee", "dukenukem3d/sprites/weapons/mighty_foot/attack_2_left" )
end
if self.Melee == 2 and self.MeleeTimer <= CurTime() then
self.Melee = 3
self.MeleeTimer = CurTime() + 0.2
self.Weapon:SetNWInt( "Melee", "dukenukem3d/sprites/weapons/mighty_foot/attack_1_left" )
end
if self.Melee == 3 and self.MeleeTimer <= CurTime() then
self.Melee = 0
self.Weapon:SetNWInt( "Melee", "dukenukem3d/sprites/weapons/mighty_foot/idle" )
end
if self.PositionDraw > FrameTime() * 150 then
self.PositionDraw = self.PositionDraw - FrameTime() * 150
end
if self.Owner:IsOnGround() then
if self.PositionX <= 64 and self.PositionXDirection == 0 then
self.PositionX = self.PositionX + FrameTime() * 50 * ( self.Owner:GetVelocity():Length() / self.Owner:GetWalkSpeed() )
end
if self.PositionX > 64 then
self.PositionXDirection = 1
end
if self.PositionX >= 0 and self.PositionXDirection == 1 then
self.PositionX = self.PositionX - FrameTime() * 50 * ( self.Owner:GetVelocity():Length() / self.Owner:GetWalkSpeed() )
end
if self.PositionX < 0 then
self.PositionXDirection = 0
end
if self.PositionY <= 32 and self.PositionYDirection == 0 then
self.PositionY = self.PositionY + FrameTime() * 50 * ( self.Owner:GetVelocity():Length() / self.Owner:GetWalkSpeed() )
end
if self.PositionY > 32 then
self.PositionYDirection = 1
end
if self.PositionY >= 0 and self.PositionYDirection == 1 then
self.PositionY = self.PositionY - FrameTime() * 50 * ( self.Owner:GetVelocity():Length() / self.Owner:GetWalkSpeed() )
end
if self.PositionY < 0 then
self.PositionYDirection = 0
end
end
if self.Weapon:Ammo1() > self.Primary.MaxAmmo then
self.Owner:SetAmmo( self.Primary.MaxAmmo, self.Primary.Ammo )
end
end